
var map_spine_player = {};

function init_spine_player(){
	
	map_spine_player = {
	
		next_motion:{
			frame:0,
			motion_name:"",
		},
		
		canvas:{},
		models:{},
		
	};

} 


var gl;
var shader;
var batcher;
var mvp = new spine.webgl.Matrix4();
var skeletonRenderer;
var assetManager;

var debugRenderer;
var shapes;

var requestId = undefined;
var stop_request = false;

var lastFrameTime;
var skeletons = {};
var swirlEffect = new spine.SwirlEffect(0);
var jitterEffect = new spine.JitterEffect(20, 20);
var swirlTime = 0;

var plugin_path = "./data/others/plugin/spine/";

TYRANO.kag.stat.spine_models = {};
TYRANO.kag.stat.spine_setting = {
	"config":{
		"version":window._spine_version,
		"default_mixval":0,
	},
	"spine_init":{},
};

init_spine_player();
        

/*
#[spine_init]
:group
Spine
:title
Spineの初期化
:exp
Spineを使用するための環境を整えます。必ず一度実行する必要がありますのでfirst.ksなどに記述しておきます。
:sample
[spine_init ]
:param
name=canvas名を設定できます。特に必要がなければ設定は不要です。デフォルトはspine_canvas,
visible=初期状態でspineを表示するか否かを指定できます。true or false。デフォルトはtrue,
layer=spine用のcanvasを配置するレイヤーを指定できます。デフォルトは0,
zindex=canvasを配置するレイヤーのzindexを指定できます。,
width=canvasの横幅を指定できます。デフォルトは画面いっぱいに配置されます,
height=canvasの高さを指定できます。デフォルトは画面いっぱいに配置されます,
left=canvasを配置する位置を指定できます。左端を基準としてピクセルで指定してください,
top=canvasを配置する位置を指定できます。上端を基準としてピクセルで指定してください,
bgimage=canvasの背景に画像を設置することができます。ファイルはbgimageフォルダに配置してください,
fps_level=数字で指定してください。0が一番なめらかです。動作が重い場合は数字を大きくすると軽量化できます。ただしクオリティは下がります。

#[end]
*/


TYRANO.kag.ftag.master_tag.spine_init = {
	kag: TYRANO.kag,
	pm: {
		
    	name:"spine_canvas",
    	
    	width:"",
    	height:"",
    	
    	left:"",
    	top:"",
    	
    	bgimage:"",
    	
    	layer:"0",
        page:"fore",
        
        zindex:"",
        
        visible:"true",
        
    	opacity:"1",
    	zindex: "1",
    	next:"true",
    	
    	fps_level:"0",
        
    },
    
	start: function(pm) {
  		
  		var that = this;
  		
  		TYRANO.kag.stat.spine_setting["spine_init"]={
	  		
	  		"name":pm.name,
	  		
	  		"width":pm.width,
	  		"height":pm.height,
	  		"left":pm.left,
	  		"top":pm.top,
	  		"zindex":pm.zindex,
	  		"visible":pm.visible,
	  		"bgimage":pm.bgimage,
	  		
	  		"fps_level":parseInt(pm.fps_level)
	  		
	  		
	  		
  		};


  		var j_canvas = $('<canvas class="'+pm.name+' spine_model" id="spine_canvas_'+pm.name+'"></canvas>');
        
        j_canvas.css("position","absolute");
        
        if(pm.visible=="false"){
	    	j_canvas.css("display","none");
	    }
        
        if(pm.width==""){
            pm.width = TYRANO.kag.config.scWidth;
        }
        
        if(pm.height==""){
            pm.height = TYRANO.kag.config.scHeight;
        }
        
        if(pm.left==""){
            pm.left = 0;
        }
        
        if(pm.top==""){
            pm.top = 0;
        }
        
        if(pm.zindex==""){
	    	j_canvas.css("z-index",parseInt(pm.zindex));   
	    }
        
        
        j_canvas.attr("width",parseInt(pm.width));
        j_canvas.attr("height",parseInt(pm.height));
        
        if (pm.zindex != "") {
        	j_canvas.css("z-index", pm.zindex);
        }
                
        var left = parseInt(pm.left);
        var top = parseInt(pm.top);;
        
        j_canvas.css("left",left);
        j_canvas.css("top",top);
        
        
		//背景画像設定
		if(pm.bgimage!=""){
			
			var background_src = "./data/bgimage/"+pm.bgimage;
			j_canvas.css("background","url("+background_src+")");
			j_canvas.css("background-size","cover");
			
		}
		
        
        
        map_spine_player["canvas"]=j_canvas.get(0);
        
        var target_layer = TYRANO.kag.layer.getLayer(pm.layer,pm.page);
        target_layer.show();
        target_layer.append(j_canvas);
        
        //canvasから
        let canvas = map_spine_player["canvas"];
    	
    	var config = { 
	    	alpha: true,
			preserveDrawingBuffer:true
	   	};
	   	
		gl = canvas.getContext("webgl", config) || canvas.getContext("experimental-webgl", config);
		if (!gl) {
			alert('WebGL is unavailable.');
			return;
		}
		
		gl.clearColor(0, 0, 0, 0);
		gl.clear(gl.COLOR_BUFFER_BIT);
		
		// Create a simple shader, mesh, model-view-projection matrix, SkeletonRenderer, and AssetManager.
		shader = spine.webgl.Shader.newTwoColoredTextured(gl);
		batcher = new spine.webgl.PolygonBatcher(gl);
		mvp.ortho2d(0, 0, canvas.width - 1, canvas.height - 1);
		skeletonRenderer = new spine.webgl.SkeletonRenderer(gl);
		window.assetManager = new spine.webgl.AssetManager(gl);
		
		// Create a debug renderer and the ShapeRenderer it needs to render lines.
		debugRenderer = new spine.webgl.SkeletonDebugRenderer(gl);
		debugRenderer.drawRegionAttachments = true;
		debugRenderer.drawBoundingBoxes = true;
		debugRenderer.drawMeshHull = true;
		debugRenderer.drawMeshTriangles = true;
		debugRenderer.drawPaths = true;
		debugShader = spine.webgl.Shader.newColored(gl);
		shapes = new spine.webgl.ShapeRenderer(gl);
        
        //requestAnimationFrame(_spine_load);
		
        if(pm.next=="true"){
            TYRANO.kag.ftag.nextOrder();
        }
		
		
	},

};


/*
#[spine_fadein]
:group
Spine
:title
Spine領域の表示 
:exp
Spineの表示領域をフェードインで表示させます。個別のモデルをフェードインさせる場合は[spine_show]タグを使用してください。
:sample
[spine_fadein time=2000 ]
:param
time=フェードインで表示される時間をミリ秒で指定できます。デフォルトは1000,
wait=フェードインの完了を待つかどうかを指定できます。true or false 。デフォルトはtrue です。
#[end]
*/


//フェードインで表示させる
TYRANO.kag.ftag.master_tag.spine_fadein = {
	
	kag: TYRANO.kag,
	vital : ["time"],
    pm: {
		
    	time:"1000",
    	wait:"true",
    	
    	
    },
    
	start: function(pm) {
  		
  		var that = this;
  		
  		TYRANO.kag.stat.spine_setting["spine_init"]["visible"]="true";
  			
  		$(map_spine_player["canvas"]).fadeIn(
	  		parseInt(pm.time),
	  		function(){
		  		TYRANO.kag.ftag.nextOrder();
		  	}
  		)
  		
  		if(pm.wait=="false"){
	  		TYRANO.kag.ftag.nextOrder();
  		}
	},

};

/*
#[spine_fadeout]
:group
Spine
:title
Spine領域の非表示 
:exp
Spineの表示領域をフェードアウトで表示させます。個別のモデルをフェードアウトさせる場合は[spine_fadeout]タグを使用してください。
:sample
[spine_fadeout time=2000 ]
:param
time=フェードインで表示される時間をミリ秒で指定できます。デフォルトは1000,
wait=フェードインの完了を待つかどうかを指定できます。true or false 。デフォルトはtrue です。
#[end]
*/

TYRANO.kag.ftag.master_tag.spine_fadeout = {
	
	kag: TYRANO.kag,
	vital : ["time"],
    pm: {
		
    	time:"1000",
    	wait:"true",
    	
    },
    
	start: function(pm) {
  		
  		var that = this;
  			
  		$(map_spine_player["canvas"]).fadeOut(
	  		parseInt(pm.time),
	  		function(){
		  		TYRANO.kag.stat.spine_setting["spine_init"]["visible"]="false";
  		  		TYRANO.kag.ftag.nextOrder();
		  	}
  		)
  		
  		if(pm.wait=="false"){
	  		TYRANO.kag.stat.spine_setting["spine_init"]["visible"] = "false";
  			TYRANO.kag.ftag.nextOrder();
  		}
	},

};


/*
#[spine_new]
:group
Spine
:title
Spineモデルの作成
:exp
Spineモデルを定義します。実行時点ではまだモデルは表示されません。
その後 [spine_show]タグで表示されます。
:sample
[spine_new name="model1" motion="walk" storage="spineboy"]
[spine_show name="model1" ]
:param
name=モデル名を指定します,
storage=ロードするモデルデータ(json or skel)指定します。データはプラグインフォルダ内のassetsフォルダ以下に配置してください。なおバイナリ形式（skel）は3.7では非対応です,
atlas=アトラスファイルを指定します。省略した場合はjsonと同一ファイル名になります,
p_alpha=true or false 指定 premultipliedAlphaの有効無効を切り替えることができます。デフォルトはtrue,
skin=適応する初期スキンを指定します。指定しない場合は「default」になります,
motion=初期モーションを指定します。

#[end]
*/




TYRANO.kag.ftag.master_tag.spine_new = {
	
	kag: TYRANO.kag,
	vital : ["name","storage","motion"],
    pm: {
		
    	name:"",
    	storage:"",
    	atlas:"",
    	
    	skin:"default",
    	
    	motion:"",
    	
    	p_alpha:"true",
    	
    	next:"true",
    	
    },
    
	start: function(_pm) {
  		
  		var that = this;
  		
  		(function(pm){
			
			//json形式の場合
			if($.getExt(pm.storage)=="json"){
				
				assetManager.loadText(plugin_path+"assets/"+pm.storage+"",function(){
		  			
		  			var atlas = pm.atlas;
		  			
		  			if(pm.atlas==""){
		  				atlas = $.replaceAll(pm.storage,".json",".atlas");
	  				}
	  				
			  		assetManager.loadTextureAtlas(plugin_path+"assets/"+atlas+"",function(){
						
					    let p_alpha = false;
					    
					    if(pm.p_alpha=="true"){
							p_alpha = true;
						}
						
						let timer_id = setInterval(function(){
							
							if(assetManager.isLoadingComplete()==false) return;
							
							clearInterval(timer_id);
							
							var skeleton = _spine_loadSkeleton(pm.storage, pm.motion, p_alpha, pm.skin);
								
							let model_name = pm.name;
							
						    map_spine_player["models"][model_name] = {
							    "skeleton":skeleton,
							    "name":model_name,
							    "storage":pm.storage,
							    "atlas":pm.atlas,
							    "p_alpha":pm.p_alpha,
							    "x":0,
							    "y":0,
							    "scale":0,
							    "visible":false,
							    "current_motion":pm.motion,
							    "skin":pm.skin,
						    };
						    
							//モデルをステータスに登録
							TYRANO.kag.stat.spine_models[model_name] = $.extend({},map_spine_player["models"][model_name]);
							delete TYRANO.kag.stat.spine_models[model_name]["skeleton"];
							
							//if(map_spine_player["stat"]["start_load_next"]=="true"){
							if(pm.next=="true"){
								TYRANO.kag.ftag.nextOrder();
							}
							//}
						
							//setupUI();
							lastFrameTime = Date.now() / 1000;
							
							//requestAnimationFrame(_spine_render);
							_start_requestframe();
								
						}, 10);
						
					    
					    //requestAnimationFrame(_spine_load);
					   	
				  	});
		    
		  		});
		  		
		  	}else if($.getExt(pm.storage)=="skel"){
			  	
			  	//binary
			  	assetManager.loadBinary(plugin_path+"assets/"+pm.storage+"",function(){
		  			
		  			let p_alpha = false;
					    
				    if(pm.p_alpha=="true"){
						p_alpha = true;
					}
					
					var atlas = pm.atlas;
						
		  			if(pm.atlas==""){
		  				atlas = pm.storage.replace(/(?:-ess|-pro)\.(skel|json)/, "") + (p_alpha ? "-pma": "") + ".atlas";
	  				}
	  				
			  		assetManager.loadTextureAtlas(plugin_path+"assets/"+atlas+"",function(){
													
						let timer_id = setInterval(function(){
							
							if(assetManager.isLoadingComplete()==false) return;
							
							clearInterval(timer_id);
						
						    var skeleton = _spine_loadSkeleton(pm.storage, pm.motion, p_alpha, pm.skin);
								
							let model_name = pm.name;
							
						    map_spine_player["models"][model_name] = {
							    "skeleton":skeleton,
							    "name":model_name,
							    "storage":pm.storage,
							    "atlas":pm.atlas,
							    "p_alpha":pm.p_alpha,
							    "x":0,
							    "y":0,
							    "scale":0,
							    "visible":false,
							    "current_motion":pm.motion,
							    "skin":pm.skin,
						    };
						    
							//モデルをステータスに登録
							TYRANO.kag.stat.spine_models[model_name] = $.extend({},map_spine_player["models"][model_name]);
							delete TYRANO.kag.stat.spine_models[model_name]["skeleton"];
							
							//if(map_spine_player["stat"]["start_load_next"]=="true"){
							if(pm.next=="true"){
								TYRANO.kag.ftag.nextOrder();
							}
							//}
						
							//setupUI();
							lastFrameTime = Date.now() / 1000;
							
							//requestAnimationFrame(_spine_render);
                            _start_requestframe();
					    
					    },10);
					    
				  	});
		    
		  		});
			  
			}
			
			
			
		})(_pm);

  		
		
	},

};

/*
#[spine_anim]
:group
Spine
:title
Spineアニメーション再生
:exp
Spineに設定しているアニメーションを再生できます。
:sample
[spine_anim name="model3" motion="roar" loop=false ]
:param
name=モデル名を指定します,
motion=再生するアニメーション名を指定します,
next_motion=このパラメータにモーションを指定しているとmotionパラメータの再生が終わった後、next_motionが再生されてループさせることができます。例えば、登場アニメ→アイドル状態といった遷移で活用すると良いでしょう。,
in_frame_next_motion=motionパラメータのアニメーションが指定フレームに到達した時点で、next_motionパラメータを再生することができます。,
loop=true or falseを指定します。falseを指定すると１度だけアニメーションを再生します。デフォルトはfalse,
slot=複数モーションを同時再生する場合はスロットに数字を指定します。デフォルトは0,

#[end]
*/


TYRANO.kag.ftag.master_tag.spine_anim = {
	
	kag: TYRANO.kag,
	vital : ["name"],
    pm: {
		name:"",
		motion:"",
		next_motion:"",
		in_frame_next_motion:"",
		loop:"false",
		next:"true",
		slot:"",
    },
    
	start: function(pm) {
  		
  		var that = this;
  		
  		var model = map_spine_player["models"][pm.name];
  		var _skeleton = model["skeleton"];
  		
        var state = _skeleton.state;
		var skeleton = _skeleton.skeleton;
		var animationName = pm.motion;
		
		skeleton.setToSetupPose();
		
		var loop = false;
		
		var slot = 0;
		
		if(pm.slot!=""){
			slot = parseInt(pm.slot);
		}
		
		if(pm.next_motion!=""){
			pm.loop="false";
			model.current_motion=pm.next_motion;
		}
		
		if(pm.loop=="true"){
			
			loop = true;
			state.setAnimation(slot, animationName, loop);
			model.current_motion = animationName;
        
        }else{
			
			state.setAnimation(slot, animationName, false);
			
			if(pm.in_frame_next_motion=="" && pm.next_motion!=""){
				
				if(slot==0){
					state.addAnimation(0, model.current_motion, true, 0);
				}
				
			}else{
				
				let frame = parseInt(pm.in_frame_next_motion);
				
				//指定フレーム後に
				if(frame >0){ 
					map_spine_player["next_motion"]={
						"frame":frame,
						"motion_name":model.current_motion,
					};
				}
				
				
			}
			
		}
		
		TYRANO.kag.stat.spine_models[pm.name] = $.extend({},map_spine_player["models"][pm.name]);
		delete TYRANO.kag.stat.spine_models[pm.name]["skeleton"];
	
        if (pm.next == "true") {
			TYRANO.kag.ftag.nextOrder();
		}
		
	},

};



/*
#[spine_anim_stop]
:group
Spine
:title
Spineアニメーション停止
:exp
Spineに設定しているアニメーションを停止できます。
:sample
[spine_anim_stop name="model3" slot="1" ]
:param
name=モデル名を指定します,
slot=再生を停止するスロットを数字で指定します,

#[end]
*/


TYRANO.kag.ftag.master_tag.spine_anim_stop = {
	
	kag: TYRANO.kag,
	vital : ["name","slot"],
    pm: {
		name:"",
		slot:"",
		duration:"0",
    },
    
	start: function(pm) {
  		
  		var that = this;
  		
  		var model = map_spine_player["models"][pm.name];
  		var _skeleton = model["skeleton"];
  		
        var state = _skeleton.state;
		var skeleton = _skeleton.skeleton;
		
		skeleton.setToSetupPose();
		
		var loop = false;
		
		var slot = 0;
		
		if(pm.slot!=""){
			slot = parseInt(pm.slot);
		}
		
		state.setEmptyAnimation(slot, parseFloat(pm.duration));
		
        TYRANO.kag.ftag.nextOrder();
		
	},

};


 
//mixアニメーション

/*
#[spine_mix_anim]
:group
Spine
:title
Spineミックスタイム設定
:exp
アニメーションペアにミックスタイムを指定できます。
すべてのモーションペアはデフォルトで0.5のミックスタイムが指定されていますが、ここで独自にミックスタイムを指定することもできます。
:sample
[spine_mix_anim name="model3" motion1="walk" motion2="roar" mixval="0.5" ]
:param
name=設定するモデル名を指定します,
motion1=前アニメーション名,
motion2=先アニメーション名,
mixval=適応するミックスタイムを指定します。

#[end]
*/	


TYRANO.kag.ftag.master_tag.spine_mix_anim = {
	
	kag: TYRANO.kag,
	vital : ["name","motion1","motion2","mixval"],
    pm: {
		name:"",
		motion1:"",
		motion2:"",
		mixval:"0.5"
    },
    
	start: function(pm) {
  		
  		var that = this;
  		
  		var model = map_spine_player["models"][pm.name];
  		var _skeleton = model["skeleton"];
  		
        var state = _skeleton.state;
		var skeleton = _skeleton.skeleton;
		
		state.data.setMix(pm.motion1, pm.motion2, parseFloat(pm.mixval));
		
        TYRANO.kag.ftag.nextOrder();
		
	},

};

function _spine_model_mod(name,pm){
	
	var model = map_spine_player["models"][name];
	var skeleton = model.skeleton.skeleton;
	
	if(pm.visible!=""){
		
		if(typeof pm.visible =="string"){
			model.visible = JSON.parse(pm.visible.toLowerCase());
		}else{
			model.visible = pm.visible;
		}
				    
	}
	
	if(pm.x!=""){
    	skeleton.x=parseInt(pm.x);
    	model.x = pm.x
	}
    
    if(pm.y!=""){
	    let tmp_y = parseInt(pm.y)*-1;  
	    skeleton.y=parseInt(tmp_y);
		model.y = pm.y
	}
	
	if(pm.scale!=""){
		skeleton.scaleX=parseFloat(pm.scale);
		skeleton.scaleY=parseFloat(pm.scale);
		model.scale = pm.scale
	
	}

	if(pm.alpha!=""){
		skeleton.color.a=parseFloat(pm.alpha);
	}
	
	if(pm.skin!=""){
		
		skeleton.setSkinByName(pm.skin);
		skeleton.setSlotsToSetupPose();
		model.skin = pm.skin;
		
	}
	
	TYRANO.kag.stat.spine_models[name] = $.extend({},map_spine_player["models"][name]);
	delete TYRANO.kag.stat.spine_models[name]["skeleton"];
			
}

/*
#[spine_show]
:group
Spine
:title
Spineモデルの表示
:exp
Spineモデルを画面に表示します。
表示するためには予め[spine_new]タグでモデルを読み込んでおく必要があります。
:sample
[spine_new name="model1" motion="walk" storage="spineboy.json"]
[spine_show name="model1" ]
:param
name=モデル名を指定します,
x=モデルのヨコ位置を指定します。縮尺が他のティラノの座標指定とは異なりますのでご注意ください。デフォルトは0,
y=モデルのタテ位置を指定します。縮尺が他のティラノの座標指定とは異なりますのでご注意ください。デフォルトは0,
scale=表示するモデルの縮尺をしていできます。デフォルトは１。,
motion=登場時に１度だけ再生されるモーションを指定できます。再生終了後は[spine_new]で指定したデフォルトモーションに戻ります。,
time=ミリ秒で指定します。モデルをフェードインしながら表示させることができます。指定しない場合は瞬時に表示されます。

#[end]
*/	

TYRANO.kag.ftag.master_tag.spine_show = {
    
    kag: TYRANO.kag,
	vital : ["name"],
    	
    pm : {
	    
        name:"",
        
        x:"",
        y:"",
        scale:"",
        alpha:"",
        
        time:"",
        wait:"true",
        motion:"", 
        
        skin:"",
        
        zindex: "1",
        next:"true",
		
    },

    start : function(pm) {

    	var that = this;
    	
    	var model = map_spine_player["models"][pm.name];
    	
    	pm["visible"] = "true";
    	
    	_spine_model_mod(pm.name,pm);
    	
    	let skeleton = model.skeleton.skeleton;
    	
    	if(pm.motion!=""){
	    	
	    	TYRANO.kag.ftag.startTag("spine_anim",{
		    	name:pm.name,
		    	motion:pm.motion,
				next:"false",
			});
			
		}
        
	    if(pm.time!=""){
			
			//表示に時間をかける
			var from_opacity = 0;
	        var to_opacity = 1;
	        
	        var easing = "linear";
	        var duration = parseInt(pm.time);
	        
	        var j_obj = $("<input type='hidden'>");
	        j_obj.css("opacity",from_opacity);
	        
	        var timer = j_obj.animate(
	            {"opacity":to_opacity},
	            {
	                duration: duration,
	                easing: easing,
	                step : (now,elem)=>{
		                skeleton.color.a = now;
	                },
	                complete:()=> {
		                
		                if(pm.wait=="true"){
			                if(pm.next=="true"){
	                    		TYRANO.kag.ftag.nextOrder();
							}
	                    }
	                    
	                }
	            }
	            
	        );
				
		}else{
			
			skeleton.color.a = 1;
			
			if(pm.wait=="true"){
				if(pm.next=="true"){
	            	TYRANO.kag.ftag.nextOrder();
				}
	        }
	            
		}
		
		if(pm.wait=="false"){
		    if(pm.next=="true"){
	            TYRANO.kag.ftag.nextOrder();
	        }
		}		
		
		
    }
        
};


/*
#[spine_mod]
:group
Spine
:title
Spineモデルの変更
:exp
Spineモデルの状態を変更します。
:sample
[spine_new name="model1" motion="walk" storage="spineboy.json"]
[spine_mod name="model1" x=200 scale=0.5 ]
:param
name=モデル名を指定します,
x=モデルのヨコ位置を指定します。縮尺が他のティラノの座標指定とは異なりますのでご注意ください。デフォルトは0,
y=モデルのタテ位置を指定します。縮尺が他のティラノの座標指定とは異なりますのでご注意ください。デフォルトは0,
scale=表示するモデルの縮尺をしていできます。デフォルトは１。,
skin=スキンを変更できます。スキン名を指定してください

#[end]
*/	

TYRANO.kag.ftag.master_tag.spine_mod = {
    
    kag: TYRANO.kag,
	vital : ["name"],
    	
    pm : {
	    
        name:"",
        
        x:"",
        y:"",
        scale:"",
        alpha:"",
        visible:"",
        skin:"",
        
        next:"true",
		
    },

    start : function(pm) {

    	var that = this;
    	var model = map_spine_player["models"][pm.name];
    	
    	_spine_model_mod(pm.name,pm);
    	
	    if(pm.next=="true"){
            TYRANO.kag.ftag.nextOrder();
        }
        
        
	
		
    }
        
};


/*
#[spine_hide]
:group
Spine
:title
Spineモデルの非表示
:exp
Spineモデルを非表示にします。
:sample
[spine_hide name="model1" time=2000 ]
:param
name=モデル名を指定します,
time=ミリ秒で指定します。モデルをフェードアウトしながら表示させることができます。指定しない場合は瞬時に表示されます。

#[end]
*/	

TYRANO.kag.ftag.master_tag.spine_hide = {
    
    kag: TYRANO.kag,
	vital : ["name"],
    	
    pm : {
	    
        name:"",
        time:"",
        wait:"true",
        next:"true",
		
    },

    start : function(pm) {

    	var that = this;
    	
    	var model = map_spine_player["models"][pm.name];
    	
    	if(pm.time!=""){
			
			//表示に時間をかける
			var from_opacity = 1;
	        var to_opacity = 0;
	        
	        var easing = "linear";
	        var duration = parseInt(pm.time);
	        
	        var j_obj = $("<input type='hidden'>");
	        j_obj.css("opacity",from_opacity);
	        
	        let skeleton = model.skeleton.skeleton;
    	    
	        var timer = j_obj.animate(
	            {"opacity":to_opacity},
	            {
	                duration: duration,
	                easing: easing,
	                step : (now,elem)=>{
		                skeleton.color.a = now;
	                },
	                complete:()=> {
		                
		                model.visible = false;
	    
		                if(pm.wait=="true"){
	                    	TYRANO.kag.ftag.nextOrder();
	                    }
	                    
	                }
	            }
	            
	        );
				
		}else{
			model.visible = false;   
			pm.wait=="false";
		}	
		
		TYRANO.kag.stat.spine_models[pm.name]["visible"] = false;
    	
		if(pm.next=="true"){
            if(pm.wait=="false"){
            	TYRANO.kag.ftag.nextOrder();
			}
        }
		
    }
        
};


function _start_requestframe(){
    
    if (!requestId) {
        requestId = requestAnimationFrame(_spine_render);
    }
    
}

function _stop_requestframe() {
    
    stop_request = true;
    
    /*
    if (requestId) {
        alert(requestId);
        cancelAnimationFrame(requestId);
        requestId = undefined;
    }
    */
    
}

var cnt_render = 0;

function _spine_render () {
	
	if(stop_request == true){
    	cancelAnimationFrame(requestId);
    	stop_request = false;
    	requestId = undefined;
        return false;
    }
	
	var fps_level = TYRANO.kag.stat.spine_setting["spine_init"]["fps_level"];
	
	/*
	console.log(fps_level);
	console.log("cnt:"+cnt_render);
	*/
		
	if (cnt_render < fps_level) {
    	
    	cnt_render++;
		//requestAnimationFrame(_spine_render);
		requestId = requestAnimationFrame(_spine_render);
		return;
		
	}
	
	cnt_render = 0;

	
	gl.clear(gl.COLOR_BUFFER_BIT);
		
	//canvasが非表示のときは描画しない
	if(TYRANO.kag.stat.spine_setting["spine_init"]["visible"] == "false"){
		return ;
	}
	
	var now = Date.now() / 1000;
	var delta = now - lastFrameTime;
	lastFrameTime = now;
	
	var models = map_spine_player["models"];
	
	for(let key in models){
		
		let model = models[key];
		
		if(model.visible==false){
			continue;
		}
			
		var _skeleton = model.skeleton;
	
		var skeleton = _skeleton.skeleton;
		var state = _skeleton.state;
		var bounds = _skeleton.bounds;
		var premultipliedAlpha = _skeleton.premultipliedAlpha;
		
					
		if(map_spine_player["next_motion"]["frame"] != 0){
			
			var currentTrack = state.getCurrent(0);
			if (currentTrack != null){
			    var currentTime = currentTrack.trackTime;
			    var currentFrame = currentTime*30; 
			    
			    //TYRANO.kag.log(map_spine_player["next_motion"]["frame"]);
			    //TYRANO.kag.log(currentFrame);
			    
				if(currentFrame >= map_spine_player["next_motion"]["frame"]) {
					
					//TYRANO.kag.log(map_spine_player["next_motion"]["motion_name"]);
					state.setAnimation(0, map_spine_player["next_motion"]["motion_name"], true);
					
					map_spine_player["next_motion"]["frame"]=0;
					map_spine_player["next_motion"]["motion_name"]="";
					 
				}
				
			}
			
		}
			
		state.update(delta);
		state.apply(skeleton);
		skeleton.updateWorldTransform();
	
		shader.bind();
		shader.setUniformi(spine.webgl.Shader.SAMPLER, 0);
		shader.setUniform4x4f(spine.webgl.Shader.MVP_MATRIX, mvp.values);
		
		batcher.begin(shader);
	
		skeletonRenderer.premultipliedAlpha = premultipliedAlpha;
		
		skeletonRenderer.draw(batcher, skeleton);
		batcher.end();
		shader.unbind();
	
		// Draw debug information.
		/*
		var debug = true;
		if (debug) {
			debugShader.bind();
			debugShader.setUniform4x4f(spine.webgl.Shader.MVP_MATRIX, mvp.values);
			debugRenderer.premultipliedAlpha = premultipliedAlpha;
			shapes.begin(debugShader);
			debugRenderer.draw(shapes, skeleton);
			shapes.end();
			debugShader.unbind();
		}
		*/
		
	}		

    requestId = requestAnimationFrame(_spine_render);
	//requestAnimationFrame(_spine_render);

}


function _spine_loadSkeleton (name, initialAnimation, premultipliedAlpha, skin) {
	
	if (skin === undefined) skin = "default";
	
	// Load the texture atlas using name.atlas from the AssetManager.
	var atlas = assetManager.get(plugin_path+"assets/" + name.replace(/(?:-ess|-pro)\.(skel|json)/, "") + (premultipliedAlpha ? "-pma": "") + ".atlas");

	// Create an AtlasAttachmentLoader that resolves region, mesh, boundingbox and path attachments
	var atlasLoader = new spine.AtlasAttachmentLoader(atlas);

	// Create a skeleton loader instance for parsing the skeleton data file.
	var skeletonLoader = name.endsWith(".skel") ? new spine.SkeletonBinary(atlasLoader) : new spine.SkeletonJson(atlasLoader);

	// Set the scale to apply during parsing, parse the file, and create a new skeleton.
	skeletonLoader.scale = 1;
	var skeletonData = skeletonLoader.readSkeletonData(assetManager.get(plugin_path+"assets/" + name));
	var skeleton = new spine.Skeleton(skeletonData);
	
	skeleton.setSkinByName(skin);
	var bounds = _spine_calculateSetupPoseBounds(skeleton);

	// Create an AnimationState, and set the initial animation in looping mode.
	var animationStateData = new spine.AnimationStateData(skeleton.data);
	var animationState = new spine.AnimationState(animationStateData);
	
	
	animationStateData.defaultMix = TYRANO.kag.stat.spine_setting["config"]["default_mixval"];
	animationState.setAnimation(0, initialAnimation, true);
	
	animationState.addListener({
		start: function(track) {
			TYRANO.kag.log("Animation on track " + track.trackIndex + " started");
		},
		interrupt: function(track) {
			TYRANO.kag.log("Animation on track " + track.trackIndex + " interrupted");
		},
		end: function(track) {
			TYRANO.kag.log("Animation on track " + track.trackIndex + " ended");
		},
		disposed: function(track) {
			TYRANO.kag.log("Animation on track " + track.trackIndex + " disposed");
		},
		complete: function(track) {
			TYRANO.kag.log("Animation on track " + track.trackIndex + " completed");
		},
		event: function(track, event) {
			
			//Event on track 0: {"time":0.16670000553131104,"data":{"name":"tyranoevent","intValue":0,"floatValue":0,"stringValue":"","audioPath":"se_in.mp3","volume":1,"balance":0},"intValue":0,"floatValue":0,"stringValue":"mode:\"once\",tag:\"playse\",storage:\"sound.mp3\",volume:\"0.5\"","volume":1,"balance":0}
			let data = event.data;
			let obj = {};
			if(data.name=="tyranoevent"){
				
				let array1 = event.stringValue.split(",");
				for(let key in array1){
					let tmp = array1[key].split(":");
					obj[tmp[0]]= $.replaceAll(tmp[1],'"','');
				}
				
				obj.stop="true";
				obj.next="false";
				
				TYRANO.kag.ftag.startTag(obj.tag,obj);
				
			}
			
		}
	})

	// Pack everything up and return to caller.
	return { skeleton: skeleton, state: animationState, bounds: bounds, premultipliedAlpha: premultipliedAlpha };
	
}

function _spine_calculateSetupPoseBounds(skeleton) {
	skeleton.setToSetupPose();
	skeleton.updateWorldTransform();
	var offset = new spine.Vector2();
	var size = new spine.Vector2();
	skeleton.getBounds(offset, size, []);
	return { offset: offset, size: size };
}

function _spine_calculateBounds(skeleton) {
	
	skeleton.setToSetupPose();
	skeleton.updateWorldTransform();
	var offset = new spine.Vector2();
	var size = new spine.Vector2();
	skeleton.getBounds(offset, size, []);
	return { offset: offset, size: size };
}


/*
 #[spine_del]
 :group
 spine
 :title
 Spineの削除
 :exp
 Spineモデルをメモリから開放して削除します。
 削除したモデルを再度使用する場合はもう一度[spine_new]が必要です。
 :sample
 [spine_del name="model1" ]

 :param
 
 #[end]

*/

TYRANO.kag.ftag.master_tag.spine_del = {
    
    kag: TYRANO.kag,
	vital : ["name"],
    pm:{
        name:"",
    },

    start : function(pm) {
		
		delete map_spine_player["models"][pm.name];
		delete TYRANO.kag.stat.spine_models[pm.name];
			        
        TYRANO.kag.ftag.nextOrder();
        
    }
        
};



/*
 #[spine_config]
 :group
 spine
 :title
 Spineの設定
 :exp
 Spine全体に影響する設定を行います
 :sample
 [spine_config mixval=0.5 ]

 :param
 mixval=Spineのすべてのアニメーションに適応されるミックス値を指定できます。個別のアニメーションにミックス値を指定したい場合は[spine_mix_anim]タグを指定してください。
 
 #[end]

*/

TYRANO.kag.ftag.master_tag.spine_config = {
    
    kag: TYRANO.kag,
	vital : [],
    pm:{
        mixval:"",
    },

    start : function(pm) {
		
		if(pm.mixval!=""){
			TYRANO.kag.stat.spine_setting["config"]["default_mixval"] = parseFloat(pm.mixval);
		}
		
			        
        TYRANO.kag.ftag.nextOrder();
        
    }
        
};



/*
 #[spine_restore]
 :group
 spine
 :title
 Spineの復元。
 :exp
 セーブデータからロード時にSpineモデルを復元するためのタグです。
 必ずmake.ksに記述してください。この記述をしないとロード時に復元できません。
 :sample
 [spine_restore ]

 :param
 
 #[end]

*/

TYRANO.kag.ftag.master_tag.spine_restore = {
    
    kag: TYRANO.kag,
	vital : [],
    pm:{
        
    },

    start : function(pm) {
		
		init_spine_player();
		
		_stop_requestframe();
	
        //モデル
        var models = $.extend({},TYRANO.kag.stat.spine_models);

        if(Object.keys(models).length <=0){
            TYRANO.kag.ftag.nextOrder();
            return;
        }
        
        //spine用のcanvasを削除
        $(".spine_canvas").remove();

        TYRANO.kag.stat.spine_models = {};
        
        let pm_init = TYRANO.kag.stat.spine_setting["spine_init"];
        pm_init["next"]="false";
        
        TYRANO.kag.ftag.startTag("spine_init",pm_init);
		
        for(key in models){

			var m = models[key];
            
            var pm = {};

            pm.name=m.name;
            pm.motion = m.current_motion;
            pm.storage = m.storage;
            pm.skin = m.skin;
            pm.next="false";
            pm.atlas=m.atlas;
            pm.p_alpha=m.p_alpha;
            pm.visible = m.visible;
            pm.atlas = m.atlas;
            
            TYRANO.kag.ftag.startTag("spine_new",pm);
            
            (function(_pm){
				
				_pm["next"] = "false";
				_pm["visible"] = m.visible;
				
	            setTimeout(function(){
	            	TYRANO.kag.ftag.startTag("spine_mod",_pm);
	            },500);
				
			})(m);
            
        }
        
        	        
        TYRANO.kag.ftag.nextOrder();
            
       	
    }
        
};


///////////////////////////////////////



